#include <cstdio>
#include <cstring>
#include <algorithm>
#include <utility>
#include <queue>
using namespace std;

const int MAXN = 10010;

bool is_h[MAXN];
vector < pair < int , int > > g[MAXN];

int n , m , h;

int d[MAXN];
bool u[MAXN];


void read()
{
    scanf ( "%d%d%d" , &n , &m , &h );

    int i , x , y , cost;
    for (i = 1; i <= h; ++i)
    {
        scanf ( "%d" , &x );
        is_h[x] = 1;
    }
    for (i = 1; i <= m; ++i)
    {
        scanf ( "%d%d%d" , &x , &y , &cost );
        g[x].push_back ( make_pair ( y , cost ) );
        g[y].push_back ( make_pair ( x , cost ) );
    }
}

void dijkstra ( int x )
{
    memset ( u , 0 , sizeof u );
    memset ( d , 0x3f , sizeof d );

    d[x] = 0;
    priority_queue < pair < int , int > > pq;

    int tx , nx , ncost , tcost , i;
    pq.push ( make_pair ( 0 , x ) );
    while ( !pq.empty() )
    {
        tx = pq.top().second;
        tcost = pq.top().first;
        pq.pop();

        if ( u[tx] ) continue;
        u[tx] = 1;

        for (i = 0; i < (int)g[tx].size(); ++i)
        {
            nx = g[tx][i].first;
            if ( d[nx] > d[tx] + g[tx][i].second )
            {
                d[nx] = d[tx] + g[tx][i].second;
                pq.push ( make_pair ( -d[nx] , nx ) );
            }
        }
    }
}

int go ( int x )
{
    dijkstra ( x );

    int res = 0;
    for (int i = 1; i <= n; ++i)
        if ( !is_h[i] )
            res += d[i];

    return res;
}

void solve()
{
    int i;
    int res = 0x3f3f3f3f;
    for (i = 1; i <= n; ++i)
        if ( is_h[i] )
            res = min ( res , go ( i ) );

    printf ( "%d\n" , res );
}

int main()
{
    read();
    solve();

    return 0;
}
