#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;

typedef long long int lli;
const double EPS = 1e-9;

struct Point
{
    double x;
    double y;

    Point ( double _x = 0. , double _y = 0. )
    {
        x = _x;
        y = _y;
    }
    void read()
    {
        scanf ( "%lf%lf" , &x , &y );
    }

    void operator -= ( const Point t )
    {
        x -= t.x;
        y -= t.y;
    }
};

vector < Point > poly[512];
vector < Point > p;

Point S;

int n , m;

void read()
{
    scanf ( "%d%d" , &n , &m );

    p.resize ( m );

    int i , j , c;
    for (i = 0; i < n; ++i)
    {
        scanf ( "%d" , &c );
        poly[i].resize ( c );

        for (j = 0; j < c; ++j)
            poly[i][j].read();
    }
    for (i = 0; i < m; ++i)
        p[i].read();
}

int cross ( Point a , Point b , Point c )
{
    c -= a;
    b -= a;
    lli t = b.x * c.y - b.y * c.x;

    if ( t > EPS ) return 1;
    if ( t < -EPS ) return -1;
    return 0;
}

bool intersect ( Point a1 , Point a2 , Point b1 , Point b2 )
{
    int t1 = cross ( b1 , a1 , a2 );
    int t2 = cross ( a2 , b1 , b2 );
    int t3 = cross ( b2 , a2 , a1 );
    int t4 = cross ( a1 , b2 , b1 );

    return t1 >= 0 && t2 >= 0 && t3 >= 0 && t4 >= 0;
}

bool go ( int id )
{
    int i , j , cc = 0;
    int sz = (int)poly[id].size();
    for (i = 0; i < m; ++i)
    {
        cc = 0;
        for (j = 0; j < sz; ++j)
            if ( intersect ( p[i] , Point ( p[i].x , 1e9 ) , poly[id][j] , poly[id][(j + 1) % sz] ) )
                ++cc;

        if ( cc & 1 ) return 1;
    }
    return 0;
}

void solve()
{
    int res = 0 , i;
    for (i = 0; i < n; ++i)
        if ( go ( i ) )
            ++res;

    printf ( "%d\n", res );
}

int main()
{   read();
    solve();

    return 0;
}
