#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;

const int MAXN = 1 << 11;
const double EPS = 1e-9;

struct Point
{
    double x , y;
    Point () {}
    Point ( double _x , double _y )
    {
        x = _x;
        y = _y;
    }
};

vector < Point > tower;
vector < Point > spot;

vector < int > g[MAXN];

bool marked[MAXN];

int n , m;

void read()
{
    scanf ( "%d%d" , &n , &m );

    char s[512];
    int i , j;
    for (i = 0; i < n; ++i)
    {
        scanf ( "%s" , s );
        for (j = 0; j < m; ++j)
        {
            if ( s[j] == '*' )
                tower.push_back ( Point ( (double)i , (double)j ) );
            if ( s[j] == 'x' )
                spot.push_back ( Point ( (double) i , (double)j ) );
        }
    }
}

double sq ( double x ) { return x * x; }

double sq_dist ( Point a , Point b )
{
    return sq ( a.x - b.x ) + sq ( a.y - b.y );
}

void dfs ( int v )
{
    marked[v] = 1;
    for (int i = 0; i < (int)g[v].size(); ++i)
        if ( !marked[ g[v][i] ] )
        {
            dfs ( g[v][i] );
        }
}

bool can ( double r )
{
    int i , j;
    int covered;

    for (i = 0; i < MAXN; ++i)
        g[i].clear();

    for (i = 0; i < (int)tower.size(); ++i)
    {
        for (j = 0; j < (int)spot.size(); ++j)
            if ( sq_dist ( tower[i] , spot[j] ) < sq ( r ) - EPS )
                g[i].push_back ( (int)tower.size() + j );

        for (j = 0; j < (int)tower.size(); ++j)
            if ( sq_dist ( tower[i] , tower[j] ) < sq ( r ) - EPS )
                g[i].push_back ( j );
    }

    for (i = 0; i < MAXN; ++i)
    {
        //if ( marked[i] )
          //  continue;

        covered = 0;
        memset ( marked , 0 , sizeof marked );
        dfs ( i );

        for (j = tower.size(); j < MAXN; ++j)
            covered += (marked[j] == 1);

        if ( covered == (int)spot.size() )
            return 1;
    }

    return 0;
}

void solve()
{
    double l = 0. , r = 1e3 , m;
    while ( l + EPS < r )
    {
        m = (l + r) / 2.;
        if ( can ( m ) )
            r = m;
        else
            l = m;
    }

    printf ( "%.6lf\n" , r );
}

int main()
{
    read();
    solve();
}
