/*
PROB: friends
LANG: C++
KEYW: 
*/
/// Thanks to Him I can know and learn! Love Christ!
/// "Without Me you can do nothing" ( John 15:5 )
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cstring>
#include <queue>
#include <ctime>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <numeric>
#include <algorithm>
#define foreach(_var,_container) for( typeof( (_container).begin() ) _var = (_container).begin() ; _var != (_container).end() ; ++_var )
#define now() double( double( clock() ) / double( CLOCKS_PER_SEC ) )
#if 0
#define eprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )
#else
#define eprintf(msg, ... ) 0
#endif
#define pprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )

typedef long long ll;

using namespace std;

const int MAXN = 1 << 14;
const int INF = 1 << 30;

struct edge{
    int dest, cost;
    edge( int dest , int cost = 0 ) : dest(dest), cost(cost) {}
};

inline bool operator < ( const edge &a , const edge &b ){
    return a.cost > b.cost;
}

int N, M, H;
vector< edge > next[MAXN];

char ishospital[MAXN];

void read(){
    scanf("%d %d %d", &N, &M, &H);
    
    for( int i = 0 ; i < H ; i++ ){
        int x;
        scanf("%d", &x);
        ishospital[x] = 1;
    }
    
    for( int i = 0 ; i < M ; i++ ){
        int a, b, cost;
        scanf("%d %d %d", &a, &b, &cost);
        
        next[a].push_back( edge( b , cost ) );
        next[b].push_back( edge( a , cost ) );
    }
}

int dijkstra( int source ){
    static int dist[MAXN];
    
    fill( dist + 1 , dist + N + 1 , INF );
    
    dist[source] = 0;
    
    priority_queue< edge > pq;
    
    pq.push( edge( source , 0 ) );
    
    while( !pq.empty() ){
        edge at = pq.top();
        pq.pop();
        
        if( dist[ at.dest ] != at.cost )
            continue;
        
        eprintf("Dist(%d) -> %d", at.dest, at.cost);
        
        for( int i = 0 ; i < (int) next[ at.dest ].size() ; i++ ){
            int to = next[ at.dest ][i].dest;
            int cost = next[ at.dest ][i].cost;
            
            if( at.cost + cost < dist[to] ){
                dist[to] = at.cost + cost;
                pq.push( edge( to , dist[to] ) );
            }
        }
    }
    
    int result = 0;
    
    for( int i = 1 ; i <= N ; i++ ){
        if( !ishospital[i] )
            result += dist[i];
    }
    
    return result;
}

void solve(){
    int best = INF;
    
    for( int i = 1 ; i <= N ; i++ ){
        if( ishospital[i] ){
            best = min( best , dijkstra( i ) );
        }
    }
    
    printf("%d\n", best);
}

int main(){
    //freopen( "5.in" , "r" , stdin );
    //freopen( "5.out" , "w" , stdout );
    
    read();
    ///init();
    solve();
    
    return 0;
}
