/*
PROB: fire
LANG: C++
KEYW:
*/
/// Thanks to Him I can know and learn! Love Christ!
/// "Without Me you can do nothing" ( John 15:5 )
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cstring>
#include <queue>
#include <ctime>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <numeric>
#include <algorithm>
#define foreach(_var,_container) for( typeof( (_container).begin() ) _var = (_container).begin() ; _var != (_container).end() ; ++_var )
#define now() double( double( clock() ) / double( CLOCKS_PER_SEC ) )
#if 0
#define eprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )
#else
#define eprintf(msg, ... ) 0
#endif
#define pprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )
 
typedef long long ll;
 
using namespace std;

const double EPS = 1e-9;

struct point{
    bool bad;
    double x,y;
    point( double x = 0 , double y = 0 ){
        this->x = x;
        this->y = y;
        this->bad = false;
    }
    friend ostream& operator<<( ostream &out , const struct point &self ){
        if( self.bad )
            out << "(bad)";
        out << "(" << self.x << "," << self.y << ")";
        return out;
    }
};

struct line{
    point a,b;
    double A,B,C;
    line( point a , point b ) : a(a) , b(b){
        double dx = b.x - a.x;
        double dy = b.y - a.y;
        A = -dy;
        B = dx;
        C = -( A*a.x + B*a.y );
    }
};

struct segment{
    point a,b;
    segment( point a , point b ) : a(a) , b(b) {}
};

inline double myabs( double x ){
    return ( x < 0.0 ? -x : x );
}

inline bool equals( double a , double b ){
    return myabs( a - b ) < EPS ? true : false;
}

inline int ccw( point a , point b , point c ){
    double x1 = b.x - a.x;
    double y1 = b.y - a.y;
    double x2 = c.x - b.x;
    double y2 = c.y - b.y;
    double cp = x1*y2 - x2*y1;
    if( equals( cp , 0.0 ) )
        return 0;
    else
        return ( cp < 0 ? -1 : 1 );
}

inline double getDist( point a , point b ){
    return sqrt( (a.x-b.x) * (a.x-b.x) + (a.y-b.y)*(a.y-b.y) );
}

inline bool online( point a , line x ){
    return equals( getDist( a , x.a ) + getDist( a , x.b ) , getDist( x.a , x.b ) );
}

inline bool crosses( segment a , segment b ){
    int d1 = ccw( a.a , b.a , b.b );
    int d2 = ccw( a.b , b.a , b.b );
    
    int d3 = ccw( b.a , a.a , a.b );
    int d4 = ccw( b.b , a.a , a.b );
    
    return 
        ( d1 * d2 < 0 
            or ( d1 == 0 and online( a.a , line( b.a , b.b ) ) )
            or ( d2 == 0 and online( a.b , line( b.a , b.b ) ) )
        ) 
        and
        ( d3 * d4 < 0
            or ( d3 == 0 and online( b.a , line( a.a , a.b ) ) )
            or ( d4 == 0 and online( b.b , line( a.a , a.b ) ) )
        );
}

bool pointInPolygon( point p , vector<point> &poly ){
    segment ray( p , point( p.x + rand() * 1000000000. , p.y + rand() * 1000000000. ) );
    
  //  cout << ray.b << endl;
    
//    cout << ray << endl;
    
    int inter = 0;
    
    for( int i = 0 ; i < poly.size() - 1 ; i++ ){
        segment a( poly[i] , poly[ i + 1 ] );
        if( crosses( a , ray ) ){
            ++inter;
        }
    }
    
    if( inter & 1 )
        return true;
    else
        return false;
}

 
const int MAXB = 1 << 9;
 
int B, S;
vector<point> zergs[MAXB];
double minx[MAXB], maxx[MAXB];
double miny[MAXB], maxy[MAXB];

char hit[MAXB];
 
void read(){
    scanf("%d %d", &B, &S);
    
    for( int i = 0 ; i < B ; i++ ){
        vector<point> &zerg = zergs[i];
        int len;
        
        scanf("%d", &len);
        
        for( int j = 0 ; j < len ; j++ ){
            double x, y;
            //scanf("%lf %lf", &zerg[i].x, &zerg[i].y);
            scanf("%lf %lf", &x, &y);
            zerg.push_back( point( x , y ) );
            
            minx[i] = min( minx[i] , x );
            maxx[i] = max( maxx[i] , x );
            miny[i] = min( miny[i] , y );
            maxy[i] = max( maxy[i] , y );
        }
        
        zerg.push_back( zerg[0] );
    }
    
    point x;
    
    for( int i = 0 ; i < S ; i++ ){        
        scanf("%lf %lf", &x.x, &x.y);
        for( int j = 0 ; j < B ; j++ )
            if( !hit[j] and minx[j] <= x.x and x.x <= maxx[j] and miny[j] <= x.y and x.y <= maxy[j] ){
                eprintf("Zerg #%d against point #%d", j + 1, i + 1);
                if( pointInPolygon( x , zergs[j] ) ){
                    eprintf("hit");
                    hit[j] = 1;
                }
            }
        
    }
    
    printf("%d\n", accumulate( hit , hit + B , 0 ));
}
 
void solve(){
     
}
 
int main(){
    //freopen( "6.in" , "r" , stdin );
    //freopen( "6.out" , "w" , stdout );
     
    read();
    ///init();
    solve();
     
    return 0;
}
