/*
PROB: chick
LANG: C++
KEYW: 
*/
/// Thanks to Him I can know and learn! Love Christ!
/// "Without Me you can do nothing" ( John 15:5 )
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cstring>
#include <queue>
#include <ctime>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <numeric>
#include <algorithm>
#define foreach(_var,_container) for( typeof( (_container).begin() ) _var = (_container).begin() ; _var != (_container).end() ; ++_var )
#define now() double( double( clock() ) / double( CLOCKS_PER_SEC ) )
#if 0
#define eprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )
#else
#define eprintf(msg, ... ) 0
#endif
#define pprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )

typedef long long ll;

using namespace std;

const int FLAG_CONDITION = 1;
const int FLAG_EFFECT = 2;

const int MAXID = 1 << 14;

enum TokenType{ 
    VARIABLE, CONSTANT, IF, THEN, PRINT, CLS, STOP, GOTO, EQUAL, LESS, GREATER, ADD, SUBTRACT, ASSIGN, DUMMY
};
enum ExprType{
    COMPOSITE, TOKEN
};

struct Token{
    TokenType type;
    int data; ///V, W, X, Y, Z -> 0,1,2,3,4,
    
    Token(){ type = DUMMY; }
    
    inline bool isOperator() const{ return type == EQUAL or  type == LESS or type == GREATER or type == ADD or type == SUBTRACT or type == ASSIGN; }
    char *getName() const{
        switch( type ){
            case VARIABLE: return "variable";
            case CONSTANT: return "constant";
            case IF: return "if";
            case THEN: return "then";
            case PRINT: return "print";
            case CLS: return "cls";
            case STOP: return "stop";
            case GOTO: return "goto";
            case EQUAL: return "equal";
            case LESS: return "less";
            case GREATER: return "greater";
            case ADD: return "add";
            case SUBTRACT: return "subtract";
            case ASSIGN: return "assign";
            default: return "dummy";
        }
    }   
    int getRank() const{
        switch( type ){
            case VARIABLE: return 0;
            case CONSTANT: return 0;
            case IF: return 10;
            case THEN: return 10;
            case PRINT: return 10;
            case CLS: return 10;
            case STOP: return 10;
            case GOTO: return 10;
            case EQUAL: return 10;
            case LESS: return 10;
            case GREATER: return 10;
            case ADD: return 10;
            case SUBTRACT: return 10;
            case ASSIGN: return 10;
            default: return -2;
        }
    }
};

struct Expression{
    Token *op;
    Expression* args[2];
    
    Expression( Token *op , Expression *arg1 = NULL , Expression *arg2 = NULL ) : op(op){
        args[0] = arg1, args[1] = arg2;
    }
};

Expression *getExpression( vector<Token*> &e , int l , int r ){
    eprintf("Expression from (%d,%d)", l, r);
    
    if( l == r ){
        return new Expression( e[l] );
    }
    
    /// special case for IF statements
    
    if( e[l]->type == IF ){
        int then = l;
        while( e[then]->type != THEN ) ++then;
        return new Expression( e[l] , getExpression( e , 1 , then - 1 ) , getExpression( e , then + 1 , r ) );
    }else if( e[l]->type == PRINT or e[l]->type == GOTO ){ /// unary operation, the horror
        e[l]->data = e[l + 1]->data;
        return new Expression( e[l] );
    }
    
    int loc = -1, best = -1;
    
    for( int i = l ; i <= r ; i++ ){
        if( e[i]->getRank() > best ) best = e[i]->getRank(), loc = i;
    }
    
    eprintf("In (%d,%d) -> max: %s", l, r, e[loc]->getName());
    
    return new Expression( e[loc] , getExpression( e , l , loc - 1 ) , getExpression( e , loc + 1 , r ) );
}

Token dummy_token;

Token *read_token( struct Token *prev , int flags , bool &end ){
    char c = getc( stdin );
    
    while( isspace(c) ){
        if( c == '\r' or c == '\n' ){
            end = true;
            return &dummy_token;
        }
        c = getc( stdin );
    }
    
    Token *result = new Token;
    
    if( isdigit(c) or ( c == '-' and prev->isOperator() ) ){
        bool negative = ( c == '-' );
        if( negative ) c = getc(stdin);
        result->type = CONSTANT;
        int &x = result->data;
        x = 0;
        do{
            x = 10 * x + (c - '0');
            c = getc( stdin );
            if( c == '\r' or c == '\n' ){
                end = true;
                break;
            }else if( c == ' ' or c == '\t' ){
                break;
            }
        }while( true );
    
        if( negative )
            result->data *= -1;
    }else if( c == 'V' or c == 'W' or c == 'X' or c == 'Y' or c == 'Z' ){
        result->type = VARIABLE;
        result->data = c - 'V';
    }else if( c == '=' ){
        /// could be compare (IF X = Y or ASSIGNMENT)
        if( flags & FLAG_CONDITION ) /// it's EQUAL
            result->type = EQUAL;
        else
            result->type = ASSIGN;
    }else if( c == '+' ){
        result->type = ADD;
    }else if( c == '-' ){ /// negative numbers already covered
        result->type = SUBTRACT;
    }else if( c == 'P' ){
        /// PRINT?
        char buff[4];
        for( int i = 0 ; i < 4 ; i++ ) buff[i] = getc( stdin );
        assert( buff[0] == 'R' and buff[1] == 'I' and buff[2] == 'N' and buff[3] == 'T' );
        result->type = PRINT;
    }else if( c == 'C' ){
        /// CLS?
        char buff[2];
        for( int i = 0 ; i < 2 ; i++ ) buff[i] = getc( stdin );
        assert( buff[0] == 'L' and buff[1] == 'S' );
        result->type = CLS;
    }else if( c == 'I' ){
        /// IF
        char buff = getc( stdin );
        assert( buff == 'F' );
        result->type = IF;
    }else if( c == 'S' ){
        /// STOP
        char buff[3];
        for( int i = 0 ; i < 3 ; i++ ) buff[i] = getc( stdin );
        assert( buff[0] == 'T' and buff[1] == 'O' and buff[2] == 'P' );
        result->type = STOP;
    }else if( c == 'G' ){
        /// GOTO
        char buff[3];
        for( int i = 0 ; i < 3 ; i++ ) buff[i] = getc( stdin );
        assert( buff[0] == 'O' and buff[1] == 'T' and buff[2] == 'O' );
        result->type = GOTO;
    }else if( c == 'T' ){
        /// THEN?
        char buff[3];
        for( int i = 0 ; i < 3 ; i++ ) buff[i] = getc( stdin );
        assert( buff[0] == 'H' and buff[1] == 'E' and buff[2] == 'N' );
        result->type = THEN;
    }else if( c == '>' ){
        result->type = GREATER;
    }else if( c == '<' ){
        result->type = LESS;
    }
    
    return result;
}

int at;
int vars[5];
int gotoed;
vector<int> output;

int exec( Expression *x ){
    eprintf("Executing op %s", x->op->getName());
    int c;// = exec( x->args[0] );
    
    switch( x->op->type ){
        case VARIABLE:
            return vars[x->op->data];
        case CONSTANT:
            return x->op->data;
        case LESS:
            return exec( x->args[0] ) < exec( x->args[1] );
        case GREATER:
            return exec( x->args[0] ) > exec( x->args[1] );
        case EQUAL:
            return exec( x->args[0] ) == exec( x->args[1] );
        case GOTO:
            gotoed = 1;
            return at = x->op->data;
        case IF:
            c = exec( x->args[0] );
            if( c )
                exec( x->args[1] );
            return c;
        case STOP:
            gotoed = 1;
            at = MAXID + 1;
            return -1;
        case CLS:
            output.clear();
            return -1;
        case ADD:
            return exec( x->args[0] ) + exec( x->args[1] );
        case SUBTRACT:
            return exec( x->args[0] ) - exec( x->args[1] );
        case PRINT:
            output.push_back( vars[ x->op->data ] );
            return -1;
        case ASSIGN:
            c = x->args[0]->op->data;
            vars[c] = exec( x->args[1] );
            return vars[c];
    }
    
    return -1;
}

int next[MAXID];
vector<int> line_ids;

Expression *cmd[MAXID];

void read(){
    
    while( true ){
        char buff[256];
        scanf("%s", buff);
        
        eprintf("buff -> %s", buff);
        
        if( !strcmp( buff , "RUN" ) ){ /// RUN
            eprintf("Running it");
            break;
        }else{
            int id;
            sscanf( buff , "%d" , &id);
            
            line_ids.push_back( id );
            
            eprintf("read id %d", id);
            
            Token *prev = &dummy_token;
            int flags = 0;
            vector<Token*> tokens;
            
            while( true ){
                bool end = false; /// end of line ?
                tokens.push_back( read_token( prev , flags , end ) );
                
                if( tokens.back()->type == DUMMY ){
                    assert( end );
                    tokens.pop_back();
                    break;
                }
                
                eprintf("Read token -> %s", tokens.back()->getName());
                
                if( tokens.back()->type == CONSTANT ) eprintf("  -> value: %d", tokens.back()->data);
                
                if( end )
                    break;
                
                prev = tokens.back();
                
                if( tokens.back()->type == IF ) flags = FLAG_CONDITION;
                else if( tokens.back()->type == THEN ) flags = FLAG_EFFECT;
            }
            
            eprintf("Parsing line #%d:", id);
            
            cmd[id] = getExpression( tokens , 0 , tokens.size() - 1 );
        }
    }
}

void solve(){
    sort( line_ids.begin() , line_ids.end() );
    
    fill( next , next + MAXID , 1 << 30 );
    
    eprintf("Got %d lines", line_ids.size());
    
    for( int i = 0 ; i < line_ids.size() - 1 ; i++ ){
        next[ line_ids[i] ] = line_ids[i + 1];
    }
    
    at = line_ids[0];
    int last = line_ids.back();
    
    while( at <= last ){
        eprintf("Executing command #%d", at);
        gotoed = 0;
        
        exec( cmd[at] );
        
        eprintf("Done!");
        
        if( gotoed ){
            continue; /// it jumped already
        }else{
            at = next[at];
        }
    }
    
    for( int i = 0 ; i < output.size() ; i++ ){
        printf("%d\n", output[i]);
    }
}

int main(){
    //freopen( "7.in" , "r" , stdin );
    //freopen( "7.out" , "w" , stdout );
    
    read();
    ///init();
    solve();
    
    return 0;
}
