/*
PROB: tower
LANG: C++
KEYW:
*/
/// Thanks to Him I can know and learn! Love Christ!
/// "Without Me you can do nothing" ( John 15:5 )
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cstring>
#include <queue>
#include <ctime>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <numeric>
#include <algorithm>
#define foreach(_var,_container) for( typeof( (_container).begin() ) _var = (_container).begin() ; _var != (_container).end() ; ++_var )
#define now() double( double( clock() ) / double( CLOCKS_PER_SEC ) )
#if 0
#define eprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )
#else
#define eprintf(msg, ... ) 0
#endif
#define pprintf(msg, ... ) fprintf(stderr," %s:%d in %s at %.4lf :: " msg "\xA" , strrchr( __FILE__ , '\\' )+1 , __LINE__ , __FUNCTION__ , now() , ##__VA_ARGS__ )
 
typedef long long ll;
 
using namespace std;
 
const int MAXN = 1 << 9;
 
int N, M, T;
vector< pair<int,int> > tower;
vector< pair<int,int> > point;
char map[MAXN][MAXN];
 
char been[MAXN][MAXN];
char tried[MAXN][MAXN];
 
int dist( int xi , int yi , int xj , int yj ){
    return (xi - xj) * (xi - xj) + (yi - yj) * (yi - yj);
}
 
bool can( double r , int t ){
    static int q[2 * MAXN * MAXN], qs, qt;
     
    memset( been , 0 , sizeof( been ) );
     
    qs = qt = 0;
     
    q[qt++] = tower[t].first;
    q[qt++] = tower[t].second;
     
    been[ tower[t].first ][ tower[t].second ] = 1;
     
    while( qs < qt ){
        int x = q[qs++];
        int y = q[qs++];
         
        //eprintf("At (%d,%d)", x, y);
         
        if( map[x][y] == '*' ){ /// collapse other towers
            tried[x][y] = 1;
            for( int i = 0 ; i < (int) tower.size() ; i++ ){
                int nx = tower[i].first, ny = tower[i].second;
                 
                double d = dist( x , y , nx , ny );
                 
                if( d <= r and been[nx][ny] == 0 ){
                    been[nx][ny] = 1;
                    q[qt++] = nx;
                    q[qt++] = ny;
                }
            }
            for( int i = 0 ; i < (int) point.size() ; i++ ){
                int nx = point[i].first, ny = point[i].second;
             
                double d = dist( x , y , nx , ny );
                 
                if( d <= r and been[nx][ny] == 0 ){
                    been[nx][ny] = 1;
                    q[qt++] = nx;
                    q[qt++] = ny;
                }
            }
        }
        /// if in a point, do nothing
    }
     
    for( int i = 0 ; i < (int) point.size() ; i++ )
        if( been[ point[i].first ][ point[i].second ] == 0 )
            return false;
     
    return true;
}
 
bool can( double r ){
    for( int i = 0 ; i < T ; i++ )
        tried[ tower[i].first ][ tower[i].second ] = 0;
    for( int i = 0 ; i < T ; i++ )
        if( !tried[ tower[i].first ][ tower[i].second ] and can( r , i ) )
            return true;
    eprintf("can(%.2lf) -> false", r);
    return false;
}
 
void read(){
    scanf("%d %d", &N, &M);
     
    for( int i = 0 ; i < N ; i++ ){
        scanf("%s", map[i]);
        for( int j = 0 ; j < M ; j++ ){
            if( map[i][j] == '*' )
                tower.push_back( make_pair( i , j ) );
            else if( map[i][j] == 'x' )
                point.push_back( make_pair( i , j ) );
        }
    }
     
    T = tower.size();
}
 
void solve(){
    double l = 0, r = N * 5;
     
    for( int i = 0 ; i < 30 ; i++ ){
        double m = ( l + r ) * 0.5;
     
        if( can(m) )
            r = m;
        else
            l = m;
    }
     
    printf("%.6lf\n", sqrt( (l + r) / 2 ));
}
 
int main(){
    //freopen( "9.in" , "r" , stdin );
    //freopen( "9.out" , "w" , stdout );
     
    read();
    ///init();
    solve();
     
    return 0;
}
