#include <cstdio>
#include <string>
#include <vector>
#include <queue>
#include <algorithm>
#include <utility>
#include <map>
#define INF 0x77777777
using namespace std;
typedef pair<int, int> pt;
typedef vector<pt> vpt;
int N, M, H;
int u, v, w, d;

map<int, bool> isHos;
vector<int> hos;
vector<vpt> G;

void read()
{
	scanf("%d%d%d", &N, &M, &H);
	hos.resize(H + 1);
	for(int i = 0; i < H; i++)
	{
		scanf("%d", &hos[i]);
		isHos[hos[i]] = true;
	}
	G.resize(N + 1);
	for(int i = 0; i < M; i++)
	{
		scanf("%d%d%d", &u, &v, &w);
		G[u].push_back(make_pair(v,w));
		G[v].push_back(make_pair(u,w));
	}
}

int solve(int s)
{
	vector<int> dist(N + 1, INF);
	priority_queue<pt, vpt, greater<pt> > pq;
	pq.push(make_pair(0, s));
	dist[s] = 0;
	pt top;
	while(!pq.empty())
	{
		top = pq.top(); pq.pop();
		d = top.first;
		u = top.second;

		if(d != dist[u])
			continue;

		for(int i = 0; i < G[u].size(); i++)
		{
			v = G[u][i].first;
			w = G[u][i].second;

			if(dist[u] + w < dist[v])
			{
				dist[v] = dist[u] + w;
				pq.push(make_pair(dist[v], v));
			}
		}
	}
	int ans = 0;
	for(int i = 1; i < dist.size(); i++) 
	{
		if(isHos.count(i) || i == s)
			continue;

		ans += dist[i];
	}	
	return ans;
}

int main()
{
//	freopen("in.txt", "r", stdin);
	read();
	int best = INF, ans;
	for(int i = 0; i < H; i++)
	{
		ans = solve(hos[i]);
		if(ans < best)
			best = ans;
	}
	printf("%d\n", best);
	return 0;
}