using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace _7.SevenDigit
{
	class SevenDigit
	{
		static List<string> combinations = new List<string>();
		static byte[] calculator;
		static byte[] digits = new byte[10]
        {
            Convert.ToByte("1111110", 2), // 0
            Convert.ToByte("0110000", 2), // 1
            Convert.ToByte("1101101", 2), // 2
            Convert.ToByte("1111001", 2), // 3
            Convert.ToByte("0110011", 2), // 4
            Convert.ToByte("1011011", 2), // 5
            Convert.ToByte("1011111", 2), // 6
            Convert.ToByte("1110000", 2), // 7
            Convert.ToByte("1111111", 2), // 8
            Convert.ToByte("1111011", 2), // 9
        };

		static char[] currentCombination;

		static void GetAllDigitCombinations(int position)
		{
			if (position == calculator.Length)
			{
				combinations.Add(new string(currentCombination));
				return;
			}
			for (int i = 0; i < digits.Length; i++)
			{
				if ((calculator[position] & digits[i]) == calculator[position])
				{
					currentCombination[position] = (char)('0' + i);
					GetAllDigitCombinations(position + 1);
				}
			}
		}

		static void Main(string[] args)
		{
			int n = int.Parse(Console.ReadLine());
			calculator = new byte[n];
			currentCombination = new char[n];
			for (int i = 0; i < n; i++)
			{
				calculator[i] = Convert.ToByte(Console.ReadLine(), 2);
			}

			GetAllDigitCombinations(0);
			Console.WriteLine(combinations.Count);
			foreach (string combination in combinations)
			{
				Console.WriteLine(combination);
			}
		}
	}
}
