using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace _5.PeshoFriends
{
	class PeshoFriends
	{
		public class Graph
		{
			private List<Tuple<int, int>>[] childNodes;
			public Graph(List<Tuple<int, int>>[] nodes)
			{
				this.childNodes = nodes;
			}

			public List<Tuple<int, int>>[] ChildNodes
			{
				get
				{
					return this.childNodes;
				}
				set
				{
					this.childNodes = value;
				}
			}
		}
		static Graph town;
		static List<int> startNodes;
		static int FindMinPaths(int startNode)
		{
			Queue<Tuple<int, int>> currentNodes = new Queue<Tuple<int, int>>(); //node and prev node
			int[] minPaths = new int[town.ChildNodes.Length];
			List<int> lastStepVisited = new List<int>();

			currentNodes.Enqueue(new Tuple<int, int>(startNode, startNode));
			minPaths[0] = 0;
			while (currentNodes.Count > 0)
			{
				Tuple<int, int> currentNode = currentNodes.Dequeue();
				foreach (var child in town.ChildNodes[currentNode.Item1])
				{
					if (startNodes.Contains(child.Item1) == false && child.Item1 != currentNode.Item2) //it's not a hospital
					{
						currentNodes.Enqueue(new Tuple<int, int>(child.Item1, currentNode.Item1));
						if (minPaths[currentNode.Item1] + child.Item2 < minPaths[child.Item1] || minPaths[child.Item1] == 0)
						{
							minPaths[child.Item1] = minPaths[currentNode.Item1] + child.Item2;
						}
					}
				}
			}
			int total = 0;
			foreach (var path in minPaths)
			{
				total += path;
			}
			return total;
		}

		static void Main(string[] args)
		{
			string[] nmh = Console.ReadLine().Split(' ');
			int n = int.Parse(nmh[0]); // all vertices
			int m = int.Parse(nmh[1]); // all edges
			int h = int.Parse(nmh[2]); // hospitals

			List<Tuple<int, int>>[] input = new List<Tuple<int, int>>[n];

			string[] hospitals = Console.ReadLine().Split(' ');
			startNodes = new List<int>();
			foreach (var hospital in hospitals)
			{
				startNodes.Add(int.Parse(hospital) - 1);
			}

			for (int i = 0; i < m; i++)
			{
				string[] currentEdge = Console.ReadLine().Split(' ');
				int first = int.Parse(currentEdge[0]) - 1;
				int second = int.Parse(currentEdge[1]) - 1;
				int length = int.Parse(currentEdge[2]);
				if (input[first] == null)
				{ input[first] = new List<Tuple<int, int>>(); }
				if (input[second] == null)
				{ input[second] = new List<Tuple<int, int>>(); }

				input[first].Add(new Tuple<int, int>(second, length));
				input[second].Add(new Tuple<int, int>(first, length));
			}

			town = new Graph(input);

			int minimum = Int32.MaxValue;
			foreach (var startNode in startNodes)
			{
				int tempMin = FindMinPaths(startNode);
				if (tempMin < minimum)
				{
					minimum = tempMin;
				}
			}
			Console.WriteLine(minimum);

		}
	}
}
