using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace _7.Chick
{
	class Chick
	{
		static string[] code;
		static int V = 0;
		static int W = 0;
		static int X = 0;
		static int Y = 0;
		static int Z = 0;

		static int GetNextLine(int currentLine, int lastLine)
		{
			for (int i = currentLine + 1; i <= lastLine; i++)
			{
				if (!string.IsNullOrWhiteSpace(code[i]))
				{
					return i;
				}
			}
			return int.MaxValue;
		}

		static int GetValue(string expression)
		{
			switch (expression.Trim())
			{
				case "":
					return 0;
				case "V":
					return V;
				case "W":
					return W;
				case "X":
					return X;
				case "Y":
					return Y;
				case "Z":
					return Z;
				default:
					return int.Parse(expression);
			}
		}

		static void Main(string[] args)
		{
			code = new string[10001];
			int lastLine = 0;

			for (int i = 0; i < code.Length; i++)
			{
				code[i] = "";
			}

			while (true)
			{
				string currentLine = Console.ReadLine();
				if (currentLine == "RUN")
				{
					break;
				}
				else
				{
					string[] lineNumberAndCommand = currentLine.Split(new char[] { ' ' }, 2);
					int lineId = int.Parse(lineNumberAndCommand[0]);
					code[lineId] = lineNumberAndCommand[1].Trim();
					lastLine = lineId;
				}
			}


			StringBuilder output = new StringBuilder();
			int currentCommandLine = GetNextLine(-1, lastLine);

			while (currentCommandLine != int.MaxValue)
			{
				string command = code[currentCommandLine];

				if (command[0] == 'I')
				{
					string[] conditionAndCommand = command.Substring(2).Split(new string[] { "THEN" }, StringSplitOptions.None);
					string condition = conditionAndCommand[0].Replace(" ", "");
					if (condition.Contains("="))
					{
						string[] values = condition.Split('=');
						if (!(GetValue(values[0]) == GetValue(values[1])))
						{
							currentCommandLine = GetNextLine(currentCommandLine, lastLine);
							continue;
						}
					}
					else if (condition.Contains(">"))
					{
						string[] values = condition.Split('>');
						if (!(GetValue(values[0]) > GetValue(values[1])))
						{
							currentCommandLine = GetNextLine(currentCommandLine, lastLine);
							continue;
						}
					}
					else if (condition.Contains("<"))
					{
						string[] values = condition.Split('<');
						if (!(GetValue(values[0]) < GetValue(values[1])))
						{
							currentCommandLine = GetNextLine(currentCommandLine, lastLine);
							continue;
						}
					}
					command = conditionAndCommand[1].Trim();
				}

				if (command[0] == 'S')
				{
					break;
				}
				else if (command[0] == 'C')
				{
					output.Clear();
				}
				else if (command[0] == 'P')
				{
					string variable = command.Substring(5).Trim();
					output.AppendLine(GetValue(variable).ToString());
				}
				else if (command[0] == 'G')
				{
					string lineIdAsString = command.Substring(4).Trim();
					currentCommandLine = int.Parse(lineIdAsString);
					continue;
				}
				else if (command.Contains("="))
				{
					string[] variableAndExpression = command.Split('=');
					string variable = variableAndExpression[0].Trim();
					string expression = variableAndExpression[1].Trim();
					int value = 0;
					if (expression.Contains("+"))
					{
						string[] expressionParts = expression.Split('+');
						value = GetValue(expressionParts[0]) + GetValue(expressionParts[1]);
					}
					else if (expression.Contains("-"))
					{
						string[] expressionParts = expression.Split('-');
						value = GetValue(expressionParts[0]) - GetValue(expressionParts[1]);
					}
					else
					{
						value = GetValue(expression);
					}
					switch (variable)
					{
						case "V":
							V = value;
							break;
						case "W":
							W = value;
							break;
						case "X":
							X = value;
							break;
						case "Y":
							Y = value;
							break;
						case "Z":
							Z = value;
							break;
						default:
							break;
					}
				}
				currentCommandLine = GetNextLine(currentCommandLine, lastLine);
			}
			Console.WriteLine(output.ToString());
		}
	}
}
