#include <cstdio>
#include <vector>
#include <queue>
#include <cstring>

using namespace std;

struct edge{
    int to, dist;

    edge ( ){};
    edge ( int t1, int t2 ){
        to = t1;
        dist = t2;
    }
};

struct vertex{
    int v, dist;

    vertex(){};
    vertex ( int t1, int t2 ){
        v = t1;
        dist = t2;
    }

    bool operator< ( vertex t1 )const {
        return dist > t1.dist;
    }
};

int N, M, H;
int isHospital[1 << 14];
int D[1 << 14], ans = 1e9;
vector < int > Hospital;
vector < edge > v[1 << 14];
int used[1 << 14];
priority_queue < vertex > q;
void scan(){
    scanf ( "%d%d%d", &N, &M, &H );

    for ( int i = 0; i < H; ++i ){
        int x;
        scanf ( "%d", &x );

        isHospital[x] = 1;
        Hospital.push_back ( x );
    }

    for ( int i = 0; i < M; ++i ){
        int l, r, dist;
        scanf ( "%d%d%d", &l, &r, &dist );

        v[l].push_back ( edge ( r, dist ) ) ;
        v[r].push_back ( edge ( l, dist ) );
    }
}

void dijkstra ( int start ){
    for ( int i = 0; i <= N; ++i )
        D[i] = 1e9;
    D[start] = 0;
    memset ( used, 0, sizeof ( used ) );
    q.push ( vertex ( start, 0 ) );

    while ( !q.empty() ){
        int i = q.top().v;
        int d = q.top().dist;
        q.pop();

        if ( used[i] ) continue;
        used[i] = 1;
    //    printf ( "%d\n", i );

        for ( int j = 0; j < v[i].size(); ++j )
            if ( !used[ v[i][j].to ] && D[ v[i][j].to ] > d + v[i][j].dist ){
                D[ v[i][j].to] = d + v[i][j].dist;
                q.push ( vertex ( v[i][j].to, D[ v[i][j].to ] ) ) ;
            }
    }

    int res = 0;

    for ( int j = 1; j <= N; ++j )
        if ( !isHospital[j] )
            res += D[j];
  /*  printf ( "%d\n", start );
    for ( int j = 1; j <= N; ++j )
        printf ( "%d ", D[j] );
    printf ( "\n" );*/

    ans = min ( ans, res );
}

void solve(){
    for ( int i = 0; i < H; ++i )
        dijkstra( Hospital[i] );
    printf ( "%d\n", ans );
}
int main(){
    scan();
    solve();
}
