#include <cstring>
#include <cmath>
#include <cstdio>
#include <vector>
#include <utility>
#include <set>

using namespace std;

struct edge{
    short f, t;
    int dist;

    bool operator< ( edge t1 )const {
        return dist < t1.dist;
    }
};

int N, M;
int all;
char a[512][512];
vector < pair < int, int > > v;
vector < pair < int, int > > vv;
int father[2048], sz[2048];
vector < pair < short, short > > e[1 << 19];

set < edge > st;

void scan(){
    scanf ( "%d%d", &N, &M );

    for ( int i = 0; i < N; ++i )
        scanf ( "%s", a + i );
}

inline int sq ( int x ){
    return x * x;
}

int root ( int t1 ){
    if ( t1 == father[t1] ) return t1;
    return father[t1] = root ( father[t1] );
}

int ok ( int mid ){
        for ( int i = 0; i < v.size(); ++i )
        father[i] = i;
    memset ( sz, 0, sizeof ( sz ) );

    int cnt = 0;

    int br[1 << 12];
    memset ( br, 0, sizeof ( br  ) );

    for ( int i = 0; i <= mid; ++i ){
        for ( int j = 0; j < e[i].size(); ++j ){
            int r1 = root ( e[i][j].first ), r2 = root ( e[i][j].second );
   //         printf ( "%d %d---\n", r1, r2 );
            if ( r1 != r2 ){
                if ( sz[r1] > sz[r2] ){
                    father[r1] = r2;
                }
                else if ( sz[r2] > sz[r1] ){
                    father[r2] = r1;
                }
                else{
                    father[r2] = r1;
                    ++sz[r2];
                }
                ++cnt;
            }
        }
        if ( cnt == N - 1 ) break;
    }

    for ( int i = 0; i <= v.size(); ++i )
        father[ i ] = root ( i );

    int pp = 0;
    for ( int qw = 0; qw < vv.size(); ++qw ){
        int i = vv[qw].first;
        int j = vv[qw].second;
            char used[v.size()], brr = 0;
            memset ( used, 0, sizeof ( used ) );
            for ( char k = 0; k < v.size(); ++k )
                if ( !used[ father[k] ] )
                    if ( sq ( i - v[k].first ) + sq ( j - v[k].second ) <= mid ){
                         br[ father[k] ] ++;
                         used[ father[k] ]= 1;++brr;
                    }
            ++pp;

            int tp = 0;

            for ( char i = 0; i <= v.size(); ++i )
                if ( br[i] == pp ) tp = 1;

            if ( !tp ) return 0;
    }

    for ( int i = 0; i <= v.size(); ++i )
        if ( br[i] == all ) return 1;
//    printf ( "%d %d %d\n", mid, cnt,  );

    return 0;
}
void solve(){
    int mx = 1e9;

    for ( int i = 0; i < N; ++i )
        for ( int j = 0; j < M; ++j )
            if ( a[i][j] == '*' ) {
                v.push_back ( make_pair ( i, j ) );
            }
            else if ( a[i][j] == 'x' ){
                ++all;
                vv.push_back ( make_pair ( i, j ) );
            }

    for ( int i = 0; i < v.size(); ++i )
        for ( int j = i + 1; j < v.size(); ++j )
            e[ sq ( v[i].first - v[j].first ) + sq ( v[j].second - v[i].second ) ].push_back ( make_pair ( i, j ) );
/*
    for ( int i = 0; i < 15; ++i ){
        printf ( "%d: ", i );
        for ( int j = 0; j < e[i].size(); ++j )
            printf ( " %d %d   ", e[i][j].first, e[i][j].second  );
        printf ( "\n" );
    }return;*/

    int l = 0, r = (1 << 19) - 1;

    while ( l + 1 < r ){
        int mid = ( l + r ) / 2;

     //   printf ( "%d %d\n", l, r );
        if ( ok ( r ) ) r = mid;
        else l = mid;
    }

    while ( !ok ( l ) ) ++l;

    printf ( "%.6f\n", sqrt ( l ));

}
int main(){
    scan();
    solve();
}
