using System;

namespace _1.Numbers
{
	static class ExamExtensions
	{
		public static bool Debugging
		{
			get
			{
#if DEBUG
				return true;
#else
				return false;
#endif
			}
		}

		public static int ToInt32(this string s)
		{
			return Convert.ToInt32(s);
		}
	}
	class Program
	{
		static int lowerBound;
		static int upperBound;
		static int divisor;
		static int remainder;

		static string GetInput()
		{
			return ExamExtensions.Debugging ? "9 31 5 1" : Console.ReadLine();
		}

		static void InitializeState()
		{
			string[] input = GetInput().Split(' ');
			lowerBound = input[0].ToInt32();
			upperBound = input[1].ToInt32();
			divisor = input[2].ToInt32();
			remainder = input[3].ToInt32();
		}

		static int GetLowestNumber()
		{
			int initialRemainder = lowerBound % divisor;
			int steps = 0;
			while (initialRemainder != remainder)
			{
				initialRemainder = (initialRemainder + 1) % divisor;
				steps++;
			}

			return lowerBound + steps;
		}

		static int GetNumbersCount()
		{
			int numbersRange = (upperBound - GetLowestNumber()) / divisor;
			if (numbersRange != 0)
			{
				numbersRange++;
			}
			return numbersRange;
		}

		static int GetNumbersCount2()
		{
			int count = 0;
			for (int i = lowerBound; i <= upperBound; i++)
			{
				if (i % divisor == remainder)
				{
					count++;
				}
			}
			return count;
		}

		static void Main(string[] args)
		{
			InitializeState();
			Console.WriteLine(GetNumbersCount2());
		}
	}
}
