#include <iostream>
#include <set>
#include <queue>
#include <vector>
#include <cstdio>
#include <cmath>
#include <string.h>

using namespace std;

#define ll long long

const int INF=1<<30;

struct NODE{
    int dist,at;
    NODE(int new_dist,int new_at){
            dist=new_dist;
            at=new_at;
    };
    inline bool operator> (const NODE &a) const{
        return dist>a.dist;
    }
};

int N,M,H;
vector< pair<int,int> > nxt[10001];
bool isHospital[10001];
vector<int> proc;
int dist[10001];
int best=INF;

void dijkstra(int x){
    priority_queue< NODE , vector<NODE> , greater<NODE> > pq;
    fill(dist,dist+N+1,INF);
    dist[x]=0;
    pq.push(NODE(0,x));
    while(!pq.empty()){
        int _at=pq.top().at;
        int d=pq.top().dist;
        pq.pop();
        if(d>dist[_at])
            continue;
        for(int i=0; i<nxt[_at].size(); i++){
            if(dist[nxt[_at][i].first]>dist[_at]+nxt[_at][i].second){
                dist[nxt[_at][i].first]=dist[_at]+nxt[_at][i].second;
                pq.push(NODE(dist[nxt[_at][i].first],nxt[_at][i].first));
            }
        }
    }
}

int main(){
    //freopen("friends.in","r",stdin);
    //freopen("friends.out","w",stdout);
    scanf("%d %d %d",&N,&M,&H);
    int temp;
    for(int i=0; i<H; i++){
        scanf("%d",&temp);
        isHospital[temp]=true;
        proc.push_back(temp);
    }
    int a,b,c;
    for(int i=0; i<M; i++){
        scanf("%d %d %d",&a,&b,&c);
        nxt[a].push_back(make_pair(b,c));
        nxt[b].push_back(make_pair(a,c));
    }
    for(int i=0; i<proc.size(); i++){
        dijkstra(proc[i]);
        int curr=0;
        for(int i=1; i<=N; i++){
            if(isHospital[i]==false){
                curr+=dist[i];
            }
        }
        best=min(best,curr);
    }
    printf("%d\n",best);
    return 0;
}
