#include <cstdio>
#include <cmath>
#include <vector>

#define eps 0.0000001
#define M_VALUE 800

using namespace std;

int m,n,szta,szto;

struct point
{
    int x,y;
};

point targets[2048],towers[2048];

inline double dist(const point &a, const point &b)
{
    return sqrt ( (double) ( (double)( (a.x - b.x) * (a.x - b.x) ) + (double)( (a.y - b.y) * (a.y - b.y) ) ) );
}

vector <int> a[2048];
int q[2048],used[2048],all[2048];

inline double abss(const double &u)
{
    if ( u < 0 ) return -u;
    return u;
}

inline bool works(const double &r)
{
    int i,j,s,p,t;

    all[0] = 0;
    for ( i=1; i<=szto; i++ ) a[i].clear();
    for ( i=1; i<=szto; i++ )
    {
        used[i] = 0;
        for ( j=i+1; j<=szto; j++ )
            if ( dist(towers[i],towers[j]) <= r )
            {
                a[i].push_back(j);
                a[j].push_back(i);
            }
    }

    int re=1,wr=1,curr;
    for ( j=1; j<=szto; j++ )
    {
        if ( used[j] ) continue;

        q[wr] = j; wr++; used[j] = 1;
        while( re < wr )
        {
            curr = q[re];
            re++;
            for ( i=0; i<a[curr].size(); i++ )
                if ( !used[ a[curr][i] ] )
                {
                    q[wr] = a[curr][i];
                    wr++;
                    used[ a[curr][i] ] = 1;
                }
        }
        all[0]++;
        all[ all[0] ] = wr-1;
    }

    int be,end;
    for ( s=1; s<=all[0]; s++ )
    {
        be = all[s-1]+1; end = all[s];
        if ( s == 1 ) be = 1;

        p=1;
        for ( i=1; i<=szta; i++ )
        {
            t=0;
            for ( j=be; j<=end; j++ )
            {
                if ( dist (targets[i],towers[ q[j] ]) <= r ) t=1;
            }
            if (!t) p=0;
        }
        if (p) return 1;
    }
    return 0;
}

int main()
{
    char c;
    int i,j;
    scanf ("%d%d",&m,&n);
    for ( i=1; i<=m; i++ )
    {
        scanf ("%c",&c);
        for ( j=1; j<=n; j++ )
        {
            scanf ("%c",&c);
            if ( c == 'x' )
            {
                szta++;
                targets[szta].x = i;
                targets[szta].y = j;
            }
            if ( c == '*' )
            {
                szto++;
                towers[szto].x = i;
                towers[szto].y = j;
            }
        }
    }

    double mid,l=0,r=M_VALUE;
    while ( r - l > eps )
    {
        mid = (l+r)/2;
        if ( works(mid) ) r = mid;
        else l = mid;
    }

    printf ("%.6lf\n",l);
}
