#include <stdio.h>

#define HOSP_MAX 101
#define G_MAX 10001
#define MAX_W 10000001

int n,m,h;
int hosp[HOSP_MAX];
int g[G_MAX][G_MAX];
int dist[G_MAX];
int used[G_MAX];

void input() {
    scanf("%d%d%d",&n,&m,&h);
    for (int i = 0; i < h; ++i) {
        scanf("%d",&hosp[i]);
    }
    int a,b;
    for (int i = 1; i <= n;++i) {
        for (int j = 1; j <= n; ++j) {
            g[i][j] = MAX_W;
        }
    }
    for (int i = 0; i < m; ++i) {
        //cout << i << " " << m << endl;
        scanf("%d%d",&a,&b);
        scanf("%d",&g[a][b]);
        g[b][a] = g[a][b];
    }
}

bool isHosp(int i) {
    for (int k = 0; k < h; ++k) {
        if (hosp[k] == i) {
            return true;
        }
    }
    return false;
}


void solve() {

    for (int k = 1; k <= n; ++k) {
        for (int i = 1; i <= n; ++i) {
            for (int j = 1; j <= n; ++j) {
                if (g[i][j] > g[i][k] + g[k][j]) {
                    g[i][j] = g[i][k] + g[k][j];
                    g[j][i] = g[i][j];
                }
            }
        }
    }


    long min = MAX_W;
    for (int i = 0; i < h; ++i) {
        int cur_min = 0;
        for (int k = 1; k<=n; ++k) {
            if (!isHosp(k)) {
                cur_min += g[hosp[i]][k];
            }
        }
        if (min > cur_min) {
            min = cur_min;
        }
    }
    printf("%d\n",min);

}

int main() {
    input();
    solve();
    return 0;
}
