#include <iostream>
#include <cstdio>
using namespace std;

#define MAXN 1000
#define MAX_VALUE 10000
#define NO_PARENT -1

int N, M, H, a[MAXN][MAXN], d[MAXN], T[MAXN];
int b[100];
bool used_h[10000];
int min_d = 1000000000;

void dijkstra( int x )
{ 
  for( int i = 0; i < N; i++ )
  if( a[x][i] )  d[i] = a[x][i];
  else           d[i] = MAX_VALUE;
  
  for( int i = 0; i < N; i++ )
  T[i] = 1;
  
  T[x] = 0;
  
  while( 1 )
  { 
    int min = MAX_VALUE;
    int p = NO_PARENT;
    
    for( int i = 0; i < N; i++ )
    if( d[i] < min && T[i] )  { min = d[i];
                                p = i;
                               }
    
    if( p == NO_PARENT )  break;
    T[p] = 0;
    
    for( int i = 0; i < N; i++ )
    if( a[p][i] && T[i] && min + a[p][i] < d[i] )  d[i] = min + a[p][i];
   }
}


void check_sol( int x )
{ 
  int sum = 0;
  for( int i = 0; i < N; i++ )
  if( !used_h[i] )  sum += d[i];
  
  if( sum < min_d )  min_d = sum;
}


int main()
{ 
  scanf("%d %d %d", &N, &M, &H);
  
  for( int i = 0; i < H; i++ )
  { 
    scanf("%d", &b[i]);
    used_h[b[i]-1] = 1;
   }
    
  int x, y, c;
  for( int i = 0; i < M; i++ )
  { 
    scanf("%d %d %d", &x, &y, &c);
    
    a[x-1][y-1] = c;
    a[y-1][x-1] = c;
   }
  
  
  // for each hospital
  for( int i = 0; i < H; i++ )
  { 
    dijkstra(b[i]-1);
    check_sol(x-1);
   }
  
  printf("%d\n", min_d);
  
  //scanf("%d", &N);
  return 0;
}
/*
5 8 2
1 2
1 2 5
4 1 2
1 3 1
3 4 4
4 5 1
2 4 3
5 2 1
2 3 20

*/
