#include <iostream>
#include <vector>
#include <string.h>

#define MAXN 19
#define DIGITS_COUNT 10
#define SEGMENTS_COUNT 7

using namespace std;

char stringToNumber(string str)
{
    char ret = 0;
    for(int i = 0; i < SEGMENTS_COUNT; i++)
    {
        ret <<= 1;
        ret |= (str[i] - '0');
    }
    return ret;
}

vector<string> answers;
int n;
char segments[MAXN];
char currentAnswer[MAXN];
char digits[DIGITS_COUNT] = { 126, 48, 109, 121, 51, 91, 95, 112, 127, 123 };

void SolveWithRecursion(int numberPosition)
{
    if (numberPosition == n)
    {
        currentAnswer[numberPosition] = '\0';
        string answer = (string)currentAnswer;
        answers.push_back(answer);
        return;
    }
    for (int i = 0; i < DIGITS_COUNT; i++)
    {
        if ((digits[i] & segments[numberPosition]) == segments[numberPosition])
        {
            currentAnswer[numberPosition] = ('0' + i);
            SolveWithRecursion(numberPosition + 1);
        }
    }
}

int main()
{
    cin >> n;
    string str;
    for(int i = 0; i < n; i++)
    {
        cin >> str;
        segments[i] = stringToNumber(str);
    }

    SolveWithRecursion(0);

    int answersCount = answers.size();
    cout << answersCount << endl;
    for(int i = 0; i < answersCount; i++)
    {
        cout << answers[i] << endl;
    }

    return 0;
}
