#include <queue>
#include <cstdio>
#include <vector>
#include <cstring>
#include <utility>
#include <iostream>
#include <algorithm>
#define MAXH (1 << 7)
#define MAXN (1 << 14)
using namespace std;

int n, m, h;
int hos[MAXH];

int isHos[MAXN];

vector< pair<int, int> > vec[MAXN];
int d[MAXN];

inline long long go(int cur) {
	memset(d, 0x7f, sizeof(d));
	priority_queue< pair<int, int> > pq;
	pq.push( make_pair(0, cur) );
	d[0] = 0;

	while (pq.size()) {
		int to = pq.top().second;
		int cost = -pq.top().first;
		pq.pop();

		if (d[to] < cost) continue;
		d[to] = cost;

		for (int i=0; i < vec[to].size(); ++i) {
			int now = vec[to][i].first;
			if (d[now] > cost + vec[to][i].second) {
				d[now] = cost + vec[to][i].second;
				pq.push( make_pair( -d[now], now) );
			}
		}
	}

	long long ret = 0;
	for (int i=1; i <= n; ++i) {
		if (!isHos[i]) ret += (long long) d[i];
	}

	return ret;
}

inline void solve() {
	long long ans = -1;
	for (int i=0; i < h; ++i) {
		long long cur = go(hos[i]);
		if (ans == -1 || ans > cur) {
			ans = cur;
		}
	}

	cout << ans << endl;
}

inline void read() {
	scanf("%d%d%d", &n, &m, &h);

	for (int i=0; i < h; ++i) {
		scanf("%d", &hos[i]);
		isHos[ hos[i] ] = 1;
	}

	for (int i=0; i < m; ++i) {
		int from, to, dist;
		scanf("%d%d%d", &from, &to, &dist);
		vec[from].push_back( make_pair(to, dist) );
		vec[to].push_back( make_pair(from, dist) );
	}
}

int main() {
	read();
	solve();
	return 0;
}
