#include <cstdio>
#include <string>
#include <vector>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#define MAXN (10005)
using namespace std;

int lines[MAXN];
string commands[MAXN];
int n, idx;

int x, y, z, v, w;
int oper[MAXN];

#define MAXX (1 << 20)
int ans[MAXX], sz;

inline void printSol() {
	for (int i=0; i < sz; ++i) {
		printf("%d\n", ans[i]);
	}
}

inline int get(string str) {
	int val = 0;
	for (int i=(str[0] == '-'); i < str.size(); ++i) {
		if (str[i] >= '0' && str[i] <= '9')
			val = val*10 + (str[i]-'0');
		else {
			switch (str[i]) {
				case 'X' : val = x; break;
				case 'Y' : val = y; break;
				case 'Z' : val = z; break;
				case 'V' : val = v; break;
				case 'W' : val = w; break;
				default : break;
			}
		}
	}

	if (str[0] == '-') return -val;
	return val;
}

inline int calc(string str) {
	string part = str.substr(str.find('=')+1);
	string left = "none", right = "0";
	char op = '#';

	for (int i=(part[0] == '-'); i < part.size(); ++i) {
		if (part[i] == '+' || part[i] == '-') {
			op = part[i];
			left = part.substr(0, i);
			right = part.substr(i+1);
			break;
		}
	}

	if (op == '#') {
		left = part;
	}

	int res = 0;
	if (op == '+') res = get(left) + get(right);
	if (op == '-') res = get(left) - get(right);
	if (op == '#') res = get(left);

	return res;
}

int eval(string str) {
	string left, right;
	char op;

	for (int i=0; i < str.size(); ++i)
		if (str[i] == '=' || str[i] == '<' || str[i] == '>') {
			left = str.substr(0, i);
			op = str[i];
			right = str.substr(i+1);
			break;
		}

	switch (op) {
		case '>' : if (get(left) > get(right)) return 1; break;
		case '<' : if (get(left) < get(right)) return 1; break;
		case '=' : if (get(left) == get(right)) return 1; break;
		default: break;
	}

	return 0;
}

void doCommand(string str) {
	if (str == "CLS") {
		sz = 0;
		return;
	}
	if (str[0] == 'P') {
		// PRINTK
		switch (str[5]) {
			case 'X' : ans[sz++] = x; break;
			case 'Y' : ans[sz++] = y; break;
			case 'Z' : ans[sz++] = z; break;
			case 'V' : ans[sz++] = v; break;
			case 'W' : ans[sz++] = w; break;
			default : break;
		}
		return;
	}

	if (str == "STOP") {
		printSol();
		exit(0);
		return;
	}

	if (str[0] == 'G') { // goto
		int line = 0;
		for (int i=0; i < str.size(); ++i) {
			if (str[i] >= '0' && str[i] <= '9')
				line = line*10 + (str[i]-'0');
		}

		idx = oper[line]-1;
		return;
	}

	string part = str.substr(str.find("=") + 1);

	switch (str[0]) {
		case 'X' : {
			x = calc(part);
			break;
		}
		case 'Y' : {
			y = calc(part);
			break;
		}
		case 'Z' : {
			z = calc(part);
			break;
		}
		case 'V' : {
			v = calc(part);
			break;
		}
		case 'W' : {
			w = calc(part);
			break;
		}
		default : break;
	}
}

inline void solve() {

	for (idx=0; idx < n; ++idx) {
		string cur = commands[idx];

		if (cur[0] == 'I' && cur[1] == 'F') { /// if
			string usl; usl.clear();
			for (int i=2; i < cur.size(); ++i) if (cur[i] != 'T') {
				usl += cur[i];
			} else break;

			int k = cur.find('N') + 1;
			string order = cur.substr(k);
			if (eval(usl))
				doCommand(order);
		} else {
			doCommand(cur);
		}

		//printf("	%d %d %d %d %d\n", x, y, z, v, w);
	}
}

inline void read() {
	n = 0;
	string str;
	while (getline(cin, str)) {
		if (str == "RUN") break;
		int j = 0;
		for (j=0; ; ++j) {
			if (str[j] >= '0' && str[j] <= '9')
				lines[n] = lines[n]*10 + (str[j]-'0');
			else break;
		}
		//printf("%d\n", j);
		oper[ lines[n] ] = n;

		for (; j < str.size(); ++j) if (str[j] != ' ')
			commands[n] += str[j];
		n++;
	}
	//printf("where?\n");
}

int main() {
	read();
	solve();
	printSol();
	return 0;
}
