#include <cmath>
#include <cstdio>
#include <vector>
#include <cstring>
#include <utility>
#include <algorithm>
#define MAXN (1 << 9)
#define EPS (1e-10)
#define x first
#define y second
using namespace std;

int n, m;
char grid[MAXN][MAXN];

vector< pair<int, int> > tower, target;

double x;

inline double dist(int idtarget, int idtower) {
	return sqrt( (tower[idtower].x-target[idtarget].x) * (tower[idtower].x-target[idtarget].x) +
				 (tower[idtower].y-target[idtarget].y) * (tower[idtower].y-target[idtarget].y) );
}

inline double distTowers(int a, int b) {
	return sqrt( (tower[a].x-tower[b].x) * (tower[a].x-tower[b].x) +
				 (tower[a].y-tower[b].y) * (tower[a].y-tower[b].y) );
}

#define MAXX (1 << 11)
int used[MAXX], amount;
int usedTar[MAXX];

void dfs(int cur) {
	used[cur] = 1;
	for (int j=0; j < target.size(); ++j) if (!usedTar[j])
		if (dist(j, cur) < x+EPS) {
			amount ++;
			usedTar[j] = 1;
		}

	for (int i=0; i < tower.size(); ++i) if (!used[i])
		if (distTowers(cur, i) < x+EPS) {
			dfs(i);
		}
}

inline int can(double mid) {
	amount = 0;
	x = mid;
	memset(used, 0, sizeof(used));
	memset(usedTar, 0, sizeof(usedTar));
	dfs(0);
	//printf("%d %d\n", amount, target.size());
	return (amount == target.size());
}

inline void solve() {
	for (int i=0; i < n; ++i)
		for (int j=0; j < m; ++j) {
			if (grid[i][j] == '*') tower.push_back( make_pair(i, j) );
			if (grid[i][j] == 'x') target.push_back( make_pair(i, j) );
		}

	double l=0, r = 1e3, mid;

	for (int i=0; i < target.size(); ++i) {
		double best = dist(i, 0);
		for (int j=1; j < tower.size(); ++j) {
			double cur = dist(i, j);
			if (best > cur+EPS)
				best = cur;
		}

		if (best > l+EPS)
			l = best;
	}

	for (int iter=0; iter < 70; ++iter) {
		mid = (l + r) / 2.;
		//printf("%lf %lf %lf\n", l, r, mid);
		if (can(mid)) r = mid;
		else l = mid;
	}

	printf("%.6lf\n", (l+r) / 2.);
}

inline void read() {
	scanf("%d%d", &n, &m);
	for (int i=0; i < n; ++i) {
		scanf("%s", grid[i]);

	}
}

int main() {
	read();
	solve();
	return 0;
}
