#include <cmath>
#include <cstdio>
#include <vector>
#include <cstring>
#include <algorithm>
using namespace std;

/*
3 3
*.*
.x.
*.*

2 6
*.***.
x.x.x.
*/

int n , m;
vector < pair < int , int > > a , b;
int c[2005][2005] , u[2005] , e;
int dist[2005][2005] , dist2[2005][2005];

void read() {
    int i , j;
    char buf[512];

    scanf ( "%d%d" , &n , &m );
    for (i = 1; i <= n; i++) {
        scanf ( "%s" , buf + 1 );

        for (j = 1; j <= m; j++) {
            if ( buf[j] == '*' ) {
                a.push_back ( make_pair ( i , j ) );
            }
            if ( buf[j] == 'x' ) {
                b.push_back ( make_pair ( i , j ) );
            }
        }
    }
}

void dfs ( int x , int len ) {
    u[x] = e;
    int i;

    for (i = 0; i < n; i++) {
        if ( !u[i] && dist[x][i] <= len ) {
            dfs ( i , len );
        }
    }
}

int can ( int len ) {
    int i , j;

    memset ( u , 0 , sizeof u );
    memset ( c , 0 , sizeof c );
    e = 0;
    for (i = 0; i < n; i++) {
        if ( !u[i] ) {
            ++ e;
            dfs ( i , len );
        }
    }

    for (i = 0; i < n; i++) {
        for (j = 0; j < m; j++) {
     //       printf ( "%d %d   %d %d   %d\n" , i , j , dist[i][j] , len , u[i] );
            if ( dist2[i][j] <= len ) {
       //         printf ( "%d\n" , j );
                c[ u[i] ][j] = 1;
            }
        }
    }

    for (i = 1; i <= e; i++) {
        for (j = 0; j < m; j++) {
            if ( !c[i][j] ) {
                break;
            }
        }

     //   printf ( "%d %d\n" , i , j );

        if ( j == m ) return 1;
    }

    return 0;
}

void solve() {
    int i , j;
    int l , r , mid;

    for (i = 0; i < (int)a.size(); i++) {
        for (j = 0; j < (int)a.size(); j++) {
            dist[i][j] = (a[i].first - a[j].first) * (a[i].first - a[j].first)
                + (a[i].second - a[j].second) * (a[i].second - a[j].second );
        }

        for (j = 0; j < (int)b.size(); j++) {
            dist2[i][j] = (a[i].first - b[j].first) * (a[i].first - b[j].first)
                + (a[i].second - b[j].second) * (a[i].second - b[j].second );
        }
    }

    n = (int)a.size();
    m = (int)b.size();

    l = 0;
    r = 1000 * 1000;

  //  printf ( "%d\n" , can ( 1 ) ); return ;

    while ( l < r ) {
        mid = l + (r - l) / 2;

        if ( can ( mid ) ) {
            r = mid;
        } else {
            l = mid + 1;
        }
    }

    printf ( "%.6lf\n" , sqrt ( (double)l ) );
}

int main() {
    read();
    solve();

    return 0;
}
