#include <iostream>
#include <vector>
#include <map>

using namespace std;

int **matrix;
int N, M, H;

vector<int> hospitals;
map<int, int> pathFromFirst;

int spanning(int startingNode)
{
	vector<int> visitedNodes;
	vector<int> notVisitedNodes;
	for (int i = 1; i < N; ++i)
	{
		bool canAdd = true;
		for (int j = 0; j < H; ++j)
		{
			if (hospitals[j] == i)
			{
				canAdd = false;
				break;
			}
		}
		if (canAdd)
		{
			notVisitedNodes.push_back(i);
			pathFromFirst[i] = -1;
		}
	}
    int result = 0;
    visitedNodes.push_back(startingNode);

	while(notVisitedNodes.size() > 0)
	{
		int currentSize = 2000000000;
		int currentNode1 = -1, currentNode2 = -1;
		bool changed = false;
		for (int i = 0; i < visitedNodes.size(); ++i)
		{
			for (int j = 0; j < notVisitedNodes.size(); ++j)
			{
				if (visitedNodes[i] != notVisitedNodes[j])
				{
					if (matrix[visitedNodes[i]][notVisitedNodes[j]] > 0 && matrix[visitedNodes[i]][notVisitedNodes[j]] < currentSize)
					{
						currentSize = matrix[visitedNodes[i]][notVisitedNodes[j]];
						currentNode1 = visitedNodes[i];
						currentNode2 = notVisitedNodes[j];
						changed = true;
					}
				}
			}
		}
		if (changed == false)
			return -1;
		visitedNodes.push_back(currentNode2);
		for(int i = 0; i < notVisitedNodes.size(); ++i)
		{
			if(notVisitedNodes[i] == currentNode2)
			{
				notVisitedNodes.erase(notVisitedNodes.begin()+i);
				break;
			}
		}
		if (currentNode1 == 0)
		{
			pathFromFirst[currentNode2] = matrix[currentNode1][currentNode2];
			result += matrix[currentNode1][currentNode2];
		}
		else
		{
			pathFromFirst[currentNode2] = matrix[currentNode1][currentNode2] + pathFromFirst[currentNode1];
			result += matrix[currentNode1][currentNode2] + pathFromFirst[currentNode1];
		}
	}
    return result;
}

int main()
{
	cin >> N >> M >> H;
	for (int i = 0; i < H; ++i)
	{
		int num;
		cin >> num;
		hospitals.push_back(num-1);
	}
	matrix = new int *[N];
	for (int i = 0; i < N; ++i)
	{
		matrix[i] = new int[N];
		for (int j = 0; j < N; ++j)
		{
			matrix[i][j] = 0;
		}
	}
	for(int i = 0; i < M; ++i)
	{
		int a, b, c;
		cin >> a >> b >> c;
		matrix[a-1][b-1] = c;
		matrix[b-1][a-1] = c;
	}

	int minPath = 2000000000;
	for (int i = 0; i < H; ++i)
	{
		int a = spanning(hospitals[i]);
		if (a < minPath && a != -1)
		{
			minPath = a;
		}
	}
	cout << minPath;
	for (int i = 0; i < N; ++i)
	{
		delete matrix[i];
	}
	delete[] matrix;
	return 0;
}