#include <cstdio>
using namespace std;

struct Point
{
	public:
		double x, y;
		Point(double x, double y)
		{
			this->x = x;
			this->y = y;
		}
		Point(){}
};

inline double abs(double a) {return a < 0 ? -a : a;}

inline double GetTriangleFace(Point a, Point b, Point c)
{
	return -(b.x - a.x) * (c.y - a.y) + (b.y - a.y) * (c.x - a.x);
}

class Polygon
{
	public:
		Point* points;
		int nPoints;
		bool killed;

		Polygon(int n)
		{
			killed = false;
			points = new Point[n];
			nPoints = n;
		}

		bool IsInPolygon(Point point)
		{
            for (int i = 1; i < nPoints - 1; i ++)
            {
                double face1 = GetTriangleFace(point, points[0], points[i]);
                double face2 = GetTriangleFace(point, points[i + 1], points[i]);
                double face3 = GetTriangleFace(point, points[0], points[i + 1]);
      
				double f = abs(GetTriangleFace(points[i + 1], points[0], points[i]));
				double t = abs(face1 + face2 + face3);

                if(f - t < 0.00001)
                    return true;
            }

            return false;
		}

};

int b, s;
double px, py;
int killed = 0;
Point current;

int main()
{
	scanf("%d%d", &b, &s);
	
	Polygon** polies = new Polygon*[b];
	int points;
	for (int i = 0; i < b; ++i)
    {
		scanf("%d", &points);
		polies[i] = new Polygon(points);

        for (int k = 0; k < points; ++k)
		{
			scanf("%Lf%Lf", &px, &py);
            polies[i]->points[k].x = px;
			polies[i]->points[k].y = py;
		}
    }

    for (int i = 0; i < s; ++i)
    {
		scanf("%Lf%Lf", &current.x, &current.y);
		
        for (int k = 0; k < b; ++ k)
            if (!polies[k]->killed)
				if (polies[k]->IsInPolygon(current))
				{
					killed++;
					polies[k]->killed = true;
				}
    }

	printf("%d", killed);
	puts("");
}