#include <cstdio>
#include <cstring>
//#include <cmath>
#include <vector>
using namespace std;

const double eps = 1e-9;

double sqrt( long long x )
{
	long double l, r, m;
	l = 0; r = 1e9;
	for ( int t = 0; t < 1000; t++ )
	{
		m=(l+r)/2;
		if ( m*m + eps < x )
		{
			l = m;
		}
		else if ( m*m + eps > x )
			r = m;
		else return m;
	}
	return (l+r)/2;
}

long long di( long long ax,  long long ay, long long bx, long long by )
{
	return (ax-bx)*(ax-bx)+(ay-by)*(ay-by);
}

vector<int> cu;

long long mi;
int n, m;
char s[1024][1024];

int lc, lp;
long long cx[2048], cy[2048];
long long px[2048], py[2048];

bool us[2048], vp[2048];

void dfs( int v )
{
	cu.push_back( v );
	int u;
	for ( u = 1; u <= lc; u++ )
	{
		if ( ( us[u] == 0 ) )
		{
//		printf( "DI %d %d : %lld %lld %lld %lld -> %lld ; %lld __ %d\n", u, v, cx[u], cy[u], cx[v], cy[v], di( cx[u], cy[u], cx[v], cy[v] ), mi, cu.size() );
			if ( ( di( cx[u], cy[u], cx[v], cy[v] ) <= mi ) )
		{
			us[u] = 1;
			dfs( u );
		}
		}
	}
}

int main()
{
	int i, j, k, all, fl;
	long long l, r;
	
	scanf( "%d %d", &n, &m );
	
	lc = 0;
	lp = 0;
	for ( i = 0; i < n; i++ )
	{
		scanf( "%s", s[i] );
		for ( j = 0; j < m; j++ )
		{
			if ( s[i][j] == '*' )
			{
				lc++;
				cx[lc] = i;
				cy[lc] = j;
			}
			else if ( s[i][j] == 'x' )
			{
				lp++;
				px[lp] = i;
				py[lp] = j;
			}
		}
	}
//	if ( lc == 0 ) while ( 1 );
	if ( lp == 0 )
	{
		printf( "%.6lf\n", 0.0 );
		return 0;
	}
	
	l = 0; r = 2000LL*2000LL*2000LL*2000LL;
//	printf( "%lld %lld\n", l, r );
	while ( l + 1 < r )
	{
//		printf( "%lld %lld\n", l, r );
		mi = (l+r)/2;
		memset( us, 0, sizeof( us ) );
		
		fl = 0;
		for ( i = 1; i <= lc; i++ )
		{
			if ( us[i] == 1 ) continue;
			cu.clear();
			us[i] = 1;
			dfs( i );
			memset( vp, 0, sizeof( vp ) );
			all = 0;
//			printf( "%d %lf %d\n", 
			for ( j = 0; j < (int)cu.size(); j++ )
			{
				for ( k = 1; k <= lp; k++ )
				{
					if ( vp[k] == 0 )
					{
						if ( di( cx[cu[j]], cy[cu[j]], px[k], py[k] ) <= mi )
						{
							vp[k] = 1;
							all++;
						}
					}
				}
			}
			if ( all == lp ) fl = 1;
			/*if ( all < lp )
			{
				break;
			}*/
		}
		//if ( i < lc )
		if ( !fl )
		{
			l = mi;
		}
		else r = mi;
	}
	
//	printf( "%lf %lf\n", l, r );
	mi = r;
	printf( "%.6lf\n", sqrt( mi ) );
	return 0;
}
